#!/usr/bin/perl -w

 #
 # Copyright (c) 2011, Enea Software AB
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
 #
 # Redistributions of source code must retain the above copyright notice, this
 # list of conditions and the following disclaimer.
 # Redistributions in binary form must reproduce the above copyright notice,
 # this list of conditions and the following disclaimer in the documentation
 # and/or other materials provided with the distribution.
 # Neither the name of Enea Software AB nor the names of its
 # contributors may be used to endorse or promote products derived from this
 # software without specific prior written permission.
 #
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 # AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 # ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 # LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 #
 # Filename: dyncontent.c
 # Date    : 14/02/2012
 # Descript: Dynamic html content generation
 # Version : 0.1
 # Author  : Daniel BORNAZ <daniel.bornaz@enea.com>

use strict;
use warnings;

my $file;
my $buff;
my $i;
my $width=15;
my $len;
my $varname;

if($#ARGV<0){
	print "No input file.\n";
	exit 1;
}

foreach $file (@ARGV){
	open(FH,"$file") or die "Cannot open $file ($!)\n";
	binmode(FH);

	$i=0;
	while(read(FH,$buff,1)){
		$i++;
	}
	$len=$i;
	seek(FH,0,0);

	$varname="char data_".$file;
	$varname=~s/\./_/g;
	print $varname."[".$i."]={";
	$i=1;
	while(read(FH,$buff,1)){
		if(!($i % $width) || $i == 1){
			printf "\n   ";
		}
		printf("0x%02x", ord($buff));
		if($i!=$len){
			printf ", ";
		}else{
			printf "\n";
		}
		$i++;
	}
	print "};\n\n";
	close(FH);
}

